; https://forum.bricsys.com/discussion/32539/link-parameters-e-g-excel
; Author: Roy Klein Gebbinck (www.b-k-g.nl)

; (csv->assoc "D:\\BKG_Tmp\\20170308\\Axl.csv")
(defun csv->assoc (fnm / hdrLst lst)
  (setq lst
    (mapcar
      '(lambda (str) (mapcar 'read (vle-string-split ",;" str)))
      (vle-file->list fnm nil)
    )
  )
  (setq hdrLst (car lst))
  (mapcar
    '(lambda (sub) (mapcar 'cons hdrLst sub))
    (cdr lst)
  )
)

(defun c:Test ( / csv dat doc dwg enmLast i opt)
  (setq doc (vla-get-activedocument (vlax-get-acad-object)))
  (vla-endundomark doc)
  (vla-startundomark doc)
  (if (setq dwg (getfiled "Insert Component" "" "dwg" 0))
    (if (setq csv (findfile (strcat (vl-filename-directory dwg) "\\" (vl-filename-base dwg) ".csv")))
      (progn
        (setq dat (csv->assoc csv))
        (textscr)
        (setq i 0)
        (foreach sub dat (princ (strcat "\n" (itoa (setq i (1+ i))) "   " (cdar sub))))
        (initget 6)
        (setq opt (getint "\nSpecify number: "))
        (graphscr)
        (setq enmLast (entlast))
        (command "_.-bminsert" dwg)
        (while (/= (logand (getvar 'cmdactive) 3) 0) (command "\\"))
        (if
          (and
            (>= i opt)
            (not (equal (entlast) enmLast))
          )
          (progn
            (setvar 'cmdecho 0)
            (foreach sub (cdr (nth (1- i) dat))
              (command "_.-bmparameters" (entlast) "" "_edit" (car sub) (cdr sub))
            )
            (setvar 'cmdecho 1)
          )
        )
      )
      (progn
        (command "_.-bminsert" dwg)
        (while (/= (logand (getvar 'cmdactive) 3) 0) (command "\\"))
      )
    )
  )
  (vla-endundomark doc)
  (princ)
)
